/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Preferences Toolbar 3.
 *
 * The Initial Developer of the Original Code is
 * Manuel Reimer.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

function hkeditSetupNew() {
    keyeditInit();
}

function hkeditSetupEdit(itemId) {
    var RitemId = RDF.GetResource(itemId);
    var Rkey = RDF.GetResource(goPrefBar.RDF.NC + "hkkey");
    var Rkeycode = RDF.GetResource(goPrefBar.RDF.NC + "hkkeycode");
    var Rmodifiers = RDF.GetResource(goPrefBar.RDF.NC + "hkmodifiers");

    var Lkey = myDatasource.GetTarget(RitemId, Rkey, true);
    var Lkeycode = myDatasource.GetTarget(RitemId, Rkeycode, true);
    var Lmodifiers = myDatasource.GetTarget(RitemId, Rmodifiers, true);

    if (Lkey) keyeditKey = Lkey.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
    if (Lkeycode) keyeditKeycode = Lkeycode.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
    if (Lmodifiers) keyeditModifiers = Lmodifiers.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;

    keyeditInit();
}

function hkeditSaveDataNew(itemId) {
    var RitemId = RDF.GetResource(itemId);
    if (keyeditKey || keyeditKeycode) {
        myDatasource.Assert(RitemId, RDF.GetResource(goPrefBar.RDF.NC + "hkkey"), RDF.GetLiteral(keyeditKey), true); 
        myDatasource.Assert(RitemId, RDF.GetResource(goPrefBar.RDF.NC + "hkkeycode"), RDF.GetLiteral(keyeditKeycode), true); 
        myDatasource.Assert(RitemId, RDF.GetResource(goPrefBar.RDF.NC + "hkmodifiers"), RDF.GetLiteral(keyeditModifiers), true); 
        myDatasource.Assert(RitemId, RDF.GetResource(goPrefBar.RDF.NC + "hkenabled"), RDF.GetLiteral("true"), true);
    }
}

function hkeditSaveDataEdit(itemId) {
    var RitemId = RDF.GetResource(itemId);
    var Rkey = RDF.GetResource(goPrefBar.RDF.NC + "hkkey");
    var Rkeycode = RDF.GetResource(goPrefBar.RDF.NC + "hkkeycode");
    var Rmodifiers = RDF.GetResource(goPrefBar.RDF.NC + "hkmodifiers");
    var Renabled = RDF.GetResource(goPrefBar.RDF.NC + "hkenabled");

    var Lkey = myDatasource.GetTarget(RitemId, Rkey, true);
    var Lkeycode = myDatasource.GetTarget(RitemId, Rkeycode, true);
    var Lmodifiers = myDatasource.GetTarget(RitemId, Rmodifiers, true);
    var Lenabled = myDatasource.GetTarget(RitemId, Renabled, true);

    if (keyeditKey || keyeditKeycode) {
        var Lnewkey = RDF.GetLiteral(keyeditKey);
        var Lnewkeycode = RDF.GetLiteral(keyeditKeycode);
        var Lnewmodifiers = RDF.GetLiteral(keyeditModifiers);
        var Lnewenabled = RDF.GetLiteral("true");

        if (Lkey)
            myDatasource.Change(RitemId, Rkey, Lkey, Lnewkey);
        else
            myDatasource.Assert(RitemId, Rkey, Lnewkey, true);

        if (Lkeycode)
            myDatasource.Change(RitemId, Rkeycode, Lkeycode, Lnewkeycode);
        else
            myDatasource.Assert(RitemId, Rkeycode, Lnewkeycode, true);

        if (Lmodifiers)
            myDatasource.Change(RitemId, Rmodifiers, Lmodifiers, Lnewmodifiers);
        else
            myDatasource.Assert(RitemId, Rmodifiers, Lnewmodifiers, true);

        if (Lenabled)
            myDatasource.Change(RitemId, Renabled, Lenabled, Lnewenabled);
        else
            myDatasource.Assert(RitemId, Renabled, Lnewenabled, true);
    }
    else {
        if (Lkey)
            myDatasource.Unassert(RitemId, Rkey, Lkey);
        if (Lkeycode)
            myDatasource.Unassert(RitemId, Rkeycode, Lkeycode);
        if (Lmodifiers)
            myDatasource.Unassert(RitemId, Rmodifiers, Lmodifiers);
        if (Lenabled)
            myDatasource.Unassert(RitemId, Renabled, Lenabled);
    }
}
